%bcond_without check 1.7.0
%bcond_with bootstrap

%if %{without bootstrap}
%global debug_package %{nil}
%endif

%global goipath         google.golang.org/grpc
%global forgeurl        https://github.com/grpc/grpc-go
Version:                1.48.0

%gometa

%global common_description %{expand:
The Go language implementation of GRPC, http/2 based rpc.}

%global godevelheader0  %{expand:
Provides: golang-google-grpc-status-devel = %{?epoch:epoch:}%{version}-%{release}
}

%global golicenses      LICENSE NOTICE.txt
%global godocs          examples AUTHORS CODE-OF-CONDUCT.md CONTRIBUTING.md\\\
                        GOVERNANCE.md MAINTAINERS.md README.md SECURITY.md\\\
                        Documentation

Name:           %{goname}
Release:    1%{?dist}
Summary:        Go language implementation of GRPC

License:        Apache-2.0
URL:            %{gourl}
Source0:        %{gosource}
Source1:        vendor.tar.gz

%description
%{common_description}

%gopkg

%prep
%goprep
tar -xzf %{SOURCE1}

%if %{without bootstrap}
%generate_buildrequires
%endif

%if %{without bootstrap}
%build
for cmd in cmd/* ; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done
%endif

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

%if %{without bootstrap}
%if %{with check}
%check
for test in "InvalidMetadata" \
            "SvrWriteStatusEarlyWrite" \
            "AuthorizationEngineEvaluate" \
            "HealthWatchServiceStatusSetBeforeStartingServer" \
            "PolicyEngineEvaluate" \
            "IdentityEncoding" \
            "Fallback" \
            "HealthCheckOff" \
            "ControlChannelCredsFailure" \
            "ClientConnCloseAfterGoAwayWithActiveStream" \
            "MaxMsgSizeServerAPI" \
            "ClientMaxHeaderListSizeServerIntentionalViolation" \
            "FailedServerStreaming" \
; do
awk -i inplace '/^func.*'"$test"'\(t/ { print; print "\tt.Skip(\"disabled failing test\")"; next}1' $(grep -rl $test)
done
%gocheck
%endif
%endif

%if %{without bootstrap}
%files
%license LICENSE NOTICE.txt
%doc examples AUTHORS CODE-OF-CONDUCT.md CONTRIBUTING.md GOVERNANCE.md
%doc MAINTAINERS.md README.md SECURITY.md Documentation
%{_bindir}/protoc-gen-go-grpc
%endif

%gopkgfiles

%changelog
* Thu Sep 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.48.0-1
- initial build
